From 5f597d791968fafedd6bf9cb2312f2df412734e2 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 17 2020 16:02:05 +0000
Subject: [PATCH 1436/2232] Implement overview diagram in ascii


---

diff --git a/book/diagram/Makefile b/book/diagram/Makefile
index d432bbe..11486ee 100644
--- a/book/diagram/Makefile
+++ b/book/diagram/Makefile
@@ -1,4 +1,4 @@
-all:
+all: overview.svg
 
 bin/asciitosvg:
 	rm -rf build
diff --git a/book/diagram/overview.ascii b/book/diagram/overview.ascii
new file mode 100644
index 0000000..c5491e4
--- /dev/null
+++ b/book/diagram/overview.ascii
@@ -0,0 +1,15 @@
+                         .-------------------------------.
+                         |                               |
+                         |      #[cxx::bridge] mod       |
+                         | definitions and declarations  |
+                         '---------------+---------------'
+                                         |
+                                         |
+                        Macro expansion  | Code generation (cxx_build, etc)
+                         +---------------+---------------+
+                         |                               |
+         Safe            |                               |
+    straightforward      v         C ABI (hidden         v      Straightforward
+       Rust APIs  .-------------.    to users)     .------------.  C++ APIs
+Rust <----------->|Rust bindings|<================>|C++ bindings|<-----------> C++
+code              '-------------'                  '------------'              code
